diff -rupN teeworlds-b177-r50edfd37-source/src//game/variables.h alien-rc4/src//game/variables.h
--- teeworlds-b177-r50edfd37-source/src//game/variables.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/variables.h	2012-06-14 23:57:39.000000000 +0200
@@ -14,6 +14,7 @@ MACRO_CONFIG_INT(ClNameplatesSize, cl_na
 MACRO_CONFIG_INT(ClAutoswitchWeapons, cl_autoswitch_weapons, 0, 0, 1, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Auto switch weapon on pickup")
 
 MACRO_CONFIG_INT(ClShowhud, cl_showhud, 1, 0, 1, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Show ingame HUD")
+MACRO_CONFIG_INT(ClShowChatFriends, cl_show_chat_friends, 0, 0, 1, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Show only chat messages from friends")
 MACRO_CONFIG_INT(ClShowfps, cl_showfps, 0, 0, 1, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Show ingame FPS counter")
 
 MACRO_CONFIG_INT(ClAirjumpindicator, cl_airjumpindicator, 1, 0, 1, CFGFLAG_CLIENT|CFGFLAG_SAVE, "")
@@ -41,7 +42,7 @@ MACRO_CONFIG_INT(PlayerColorBody, player
 MACRO_CONFIG_INT(PlayerColorFeet, player_color_feet, 65408, 0, 0xFFFFFF, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Player feet color")
 MACRO_CONFIG_STR(PlayerSkin, player_skin, 24, "default", CFGFLAG_CLIENT|CFGFLAG_SAVE, "Player skin")
 
-MACRO_CONFIG_INT(UiPage, ui_page, 5, 0, 10, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Interface page")
+MACRO_CONFIG_INT(UiPage, ui_page, 6, 0, 10, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Interface page")
 MACRO_CONFIG_INT(UiToolboxPage, ui_toolbox_page, 0, 0, 2, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Toolbox page")
 MACRO_CONFIG_STR(UiServerAddress, ui_server_address, 64, "localhost:8303", CFGFLAG_CLIENT|CFGFLAG_SAVE, "Interface server address")
 MACRO_CONFIG_INT(UiScale, ui_scale, 100, 50, 150, CFGFLAG_CLIENT|CFGFLAG_SAVE, "Interface scale")
@@ -60,10 +61,11 @@ MACRO_CONFIG_STR(SvMotd, sv_motd, 900, "
 MACRO_CONFIG_INT(SvTeamdamage, sv_teamdamage, 0, 0, 1, CFGFLAG_SERVER, "Team damage")
 MACRO_CONFIG_STR(SvMaprotation, sv_maprotation, 768, "", CFGFLAG_SERVER, "Maps to rotate between")
 MACRO_CONFIG_INT(SvRoundsPerMap, sv_rounds_per_map, 1, 1, 100, CFGFLAG_SERVER, "Number of rounds on each map before rotating")
+MACRO_CONFIG_INT(SvRoundSwap, sv_round_swap, 1, 0, 1, CFGFLAG_SERVER, "Swap teams between rounds")
 MACRO_CONFIG_INT(SvPowerups, sv_powerups, 1, 0, 1, CFGFLAG_SERVER, "Allow powerups like ninja")
-MACRO_CONFIG_INT(SvScorelimit, sv_scorelimit, 20, 0, 1000, CFGFLAG_SERVER, "Score limit (0 disables)")
-MACRO_CONFIG_INT(SvTimelimit, sv_timelimit, 0, 0, 1000, CFGFLAG_SERVER, "Time limit in minutes (0 disables)")
-MACRO_CONFIG_STR(SvGametype, sv_gametype, 32, "dm", CFGFLAG_SERVER, "Game type (dm, tdm, ctf)")
+MACRO_CONFIG_INT(SvScorelimit, sv_scorelimit, 0, 0, 1000, CFGFLAG_SERVER, "Score limit (0 disables)")
+MACRO_CONFIG_INT(SvTimelimit, sv_timelimit, 4, 0, 1000, CFGFLAG_SERVER, "Time limit in minutes (0 disables)")
+MACRO_CONFIG_STR(SvGametype, sv_gametype, 32, "alien", CFGFLAG_SERVER, "Game type (dm, tdm, ctf)")
 MACRO_CONFIG_INT(SvTournamentMode, sv_tournament_mode, 0, 0, 1, CFGFLAG_SERVER, "Tournament mode. When enabled, players joins the server as spectator")
 MACRO_CONFIG_INT(SvSpamprotection, sv_spamprotection, 1, 0, 1, CFGFLAG_SERVER, "Spam protection")
 
@@ -80,6 +82,73 @@ MACRO_CONFIG_INT(SvVoteSpectateRejoindel
 MACRO_CONFIG_INT(SvVoteKick, sv_vote_kick, 1, 0, 1, CFGFLAG_SERVER, "Allow voting to kick players")
 MACRO_CONFIG_INT(SvVoteKickMin, sv_vote_kick_min, 0, 0, MAX_CLIENTS, CFGFLAG_SERVER, "Minimum number of players required to start a kick vote")
 MACRO_CONFIG_INT(SvVoteKickBantime, sv_vote_kick_bantime, 5, 0, 1440, CFGFLAG_SERVER, "The time to ban a player if kicked by vote. 0 makes it just use kick")
+MACRO_CONFIG_INT(SvPreStartDelay, sv_prestartdelay, 10,1,10000, CFGFLAG_SERVER, "Warmup-phase at start")
+MACRO_CONFIG_INT(SvSingularityRangeW, sv_singularityrange_w, 800, 1, 9999, CFGFLAG_SERVER, "Weapon singularity range")
+MACRO_CONFIG_INT(SvSingularityRangeS, sv_singularityrange_s, 1600, 1, 9999, CFGFLAG_SERVER, "Mapentity singularity range")
+MACRO_CONFIG_INT(SvSingularityKillRange, sv_singularitykillrange, 40, 1, 1000, CFGFLAG_SERVER, "Deathzone of singularity")
+MACRO_CONFIG_INT(SvSingularinatorTTL, sv_singularinatorttl,10,1,9999,CFGFLAG_SERVER, "Singularity TTL of Singularinator")
+MACRO_CONFIG_INT(SvMinScorePlayers, sv_minscoreplayers,1,1,16,CFGFLAG_SERVER, "Minimum of players before high-score would be written.")
+MACRO_CONFIG_STR(SvHighScorePath, sv_highscorepath, 2048, "./", CFGFLAG_SERVER, "Pathname for high-score files.")
+MACRO_CONFIG_STR(SvStartMsgA, sv_startmsg_a, 128, "And so it began...", CFGFLAG_SERVER, "Startmsg 1 for humans")
+MACRO_CONFIG_STR(SvStartMsgB, sv_startmsg_b, 128, "A storm is brewing...", CFGFLAG_SERVER, "Startmsg 2 for humans")
+MACRO_CONFIG_STR(SvStartMsgC, sv_startmsg_c, 128, "Is there still hope?", CFGFLAG_SERVER, "Startmsg 3 for humans")
+MACRO_CONFIG_STR(SvStartMsgD, sv_startmsg_d, 128, "Please insert coin!", CFGFLAG_SERVER, "Startmsg 4 for humans")
+MACRO_CONFIG_INT(SvMutEmoteDelay, sv_mutemotedelay,20,5,9999,CFGFLAG_SERVER, "Base-delay of random protecting mutantic eye flashing (+10 secs rand)")
+MACRO_CONFIG_INT(SvSGTurretNonExpDmg, sv_sgturret_nonexpdmg,2,0,4,CFGFLAG_SERVER, "Damage of stationary shotgun-turret (final_sum = +1 for exploding_dmg)")
+MACRO_CONFIG_INT(SvAirStrikeTTL, sv_airstrikettl,1500,1,9999,CFGFLAG_SERVER, "TTL for airstrike grenades")
+MACRO_CONFIG_INT(SvInitAirStrike, sv_initairstrike,1,0,1,CFGFLAG_SERVER, "Do random airstrike at start")
+MACRO_CONFIG_INT(SvClusters, sv_clusters,6,0,64,CFGFLAG_SERVER, "How many clusters per grenade")
+MACRO_CONFIG_INT(SvAirStrikeClusters, sv_airstrikeclusters,6,0,24,CFGFLAG_SERVER, "How many clusters per human airstrike-grenade")
+MACRO_CONFIG_INT(SvAlicaAirStrikeStep, sv_alica_airstrikestep,128,32,9999,CFGFLAG_SERVER, "Size of space between bomb-carpet of alica")
+MACRO_CONFIG_INT(SvHumAirStrikeStep, sv_hum_airstrikestep,128,32,9999,CFGFLAG_SERVER, "Size of space between bomb-carpet of humans")
+MACRO_CONFIG_INT(SvReaperAmmo, sv_reaperammo,2,0,10,CFGFLAG_SERVER, "How many singularities at reaper start")
+MACRO_CONFIG_INT(SvHealingAmmo, sv_healingammo,3,0,10,CFGFLAG_SERVER, "How many healing laser ammo")
+MACRO_CONFIG_INT(SvGunMK2Force, sv_gunmk2force,20,0,9999,CFGFLAG_SERVER, "How many force for gun mk2")
+MACRO_CONFIG_INT(SvShotMK2Force, sv_shotmk2force,10,0,9999,CFGFLAG_SERVER, "How many force for shotgun mk2")
+MACRO_CONFIG_INT(SvShotSpeedkit, sv_shotspeedkit,700,250,2000,CFGFLAG_SERVER, "Shotgun-Speedkit reload delay")
+MACRO_CONFIG_INT(SvScienceSuccessCount, sv_sciencesuccesscount,10,0,9999,CFGFLAG_SERVER, "How many shields for research (0 to disable)")
+MACRO_CONFIG_INT(SvSaveScienceScore, sv_savesciencescore,0,0,9999,CFGFLAG_SERVER, "Save double researches after round at min score (0 to disable)")
+MACRO_CONFIG_INT(SvScienceSpawn, sv_sciencespawn,400,0,2000,CFGFLAG_SERVER, "Time in msecs until hammer respawns at research")
+MACRO_CONFIG_INT(SvSkipScienceStations, sv_skipsciencestations,0,0,1,CFGFLAG_SERVER, "Remove science stations when map is loaded")
+MACRO_CONFIG_INT(SvMaxTurretAimVel, sv_maxturretaimvel,10,0,9999,CFGFLAG_SERVER, "Max movement speed before turret will fire on tee")
+MACRO_CONFIG_INT(SvTurretAimNoHumans, sv_turretaimnohumans,0,0,1,CFGFLAG_SERVER, "Laserturrets should just aim mutants")
+MACRO_CONFIG_INT(SvTurretRange, sv_turretrange,500,0,1000,CFGFLAG_SERVER, "Range of laserturrets")
+MACRO_CONFIG_INT(SvLaserWallDelay, sv_laserwalldelay, 1, 0, 5, CFGFLAG_SERVER, "Delay before laserwall would be activated")
+MACRO_CONFIG_INT(SvLaserWallLength, sv_laserwalllength, 266, 0, 9999, CFGFLAG_SERVER, "Length for one hit laserwall")
+MACRO_CONFIG_INT(SvNormalBattery, sv_normalbattery,3000,1,9999,CFGFLAG_SERVER, "Time that one shield keep laserwall on power")
+MACRO_CONFIG_INT(SvSuperBattery, sv_superbattery,4500,1,9999,CFGFLAG_SERVER, "Time that one shield keep laserwall on power")
+MACRO_CONFIG_INT(SvLWLimit, sv_lw_limit,0,0,1,CFGFLAG_SERVER, "Limit TTL of laserwall to 10 x batterypower")
+MACRO_CONFIG_INT(SvLWLimitNonAlMap, sv_lw_limit_non_al_map,1,0,1,CFGFLAG_SERVER, "Limit TTL of laserwall to 10 x batterypower in non-alien maps")
+MACRO_CONFIG_INT(SvHeroAirstrike, sv_heroairstrike,0,0,1,CFGFLAG_SERVER, "Give airstrike when player get hero")
+MACRO_CONFIG_INT(SvReapinatorDisabled, sv_reapinator_disabled,0,0,1,CFGFLAG_SERVER, "Disable reapinator")
+MACRO_CONFIG_INT(SvReapinatorDelay, sv_reapinator_delay,120,1,9999,CFGFLAG_SERVER, "Init delay of reapinator (in secs)")
+MACRO_CONFIG_INT(SvReapinatorMinScore, sv_reapinator_minscore,5,0,9999,CFGFLAG_SERVER, "Min player score for reapinator")
+MACRO_CONFIG_INT(SvReaperMinScore, sv_reaper_minscore,6,0,9999,CFGFLAG_SERVER, "Min player score for reaper (without reapinator)")
+MACRO_CONFIG_INT(SvMetamorphoseCount, sv_metamorphosecount,1,0,9999,CFGFLAG_SERVER, "How many kills until metamorphose")
+MACRO_CONFIG_INT(SvHeroBecameScore, sv_becamehero_score,15,0,9999,CFGFLAG_SERVER, "Score to became hero")
+MACRO_CONFIG_INT(SvAutoResearchScore, sv_autoresearchscore, 3,0,9999,CFGFLAG_SERVER, "BonusScore to init research lottery - (0 to disable)")
+MACRO_CONFIG_INT(SvEmptyResearch, sv_emptyresearch, 1,0,1,CFGFLAG_SERVER, "Auto research only on maps without hammer pickup")
+MACRO_CONFIG_STR(SvInfoGot, sv_infogot, 64, "got:", CFGFLAG_SERVER, "Autoresearch text success text")
+MACRO_CONFIG_STR(SvInfoResearched, sv_inforesearched, 64, "researched:", CFGFLAG_SERVER, "Manual hammer research success text")
+MACRO_CONFIG_STR(SvInfoHackedAirstrike, sv_hackedairstrike, 64, "hacked Alica-AI and got an airstrike!", CFGFLAG_SERVER, "Became airstrike text at research")
+MACRO_CONFIG_STR(SvInfoGotAirstrike, sv_gotairstrike, 64, "got an airstrike!", CFGFLAG_SERVER, "Became airstrike text no-research")
+MACRO_CONFIG_INT(SvScepticMsgOn, sv_scepticmsg_on, 1,0,1,CFGFLAG_SERVER, "Enable energynator sceptic msg.")
+MACRO_CONFIG_INT(SvHappyMsgOn, sv_happymsg_on, 1,0,1,CFGFLAG_SERVER, "Enable energynator sceptic msg.")
+MACRO_CONFIG_INT(SvBonusMsgOn, sv_bonusmsg_on, 1,0,1,CFGFLAG_SERVER, "Enable generic research and metamorph-messages.")
+MACRO_CONFIG_STR(SvScepticEnergynatorA, sv_scepticenergynator_a, 128, "Energynator: You are a mutant, aren't you?", CFGFLAG_SERVER, "Sceptic energynator text 1")
+MACRO_CONFIG_STR(SvScepticEnergynatorB, sv_scepticenergynator_b, 128, "Energynator: Starting fillup... Hey wait a minute!", CFGFLAG_SERVER, "Sceptic energynator text 2")
+MACRO_CONFIG_STR(SvScepticEnergynatorC, sv_scepticenergynator_c, 128, "Energynator: Go away scary mutant!", CFGFLAG_SERVER, "Sceptic energynator text 3")
+MACRO_CONFIG_STR(SvScepticEnergynatorD, sv_scepticenergynator_d, 128, "Energynator: :P", CFGFLAG_SERVER, "Sceptic energynator text 4")
+MACRO_CONFIG_STR(SvScepticEnergynatorE, sv_scepticenergynator_e, 128, "Energynator: Help!!! I'm getting raped by mutants!", CFGFLAG_SERVER, "Sceptic energynator text 5")
+MACRO_CONFIG_STR(SvHappyReapinatorA, sv_happyreapinator_a, 128, "Reapinator: Hello alien-reaper. I'm your personal fan (but don't tell this energynator)", CFGFLAG_SERVER, "Happy reapinator text 1")
+MACRO_CONFIG_STR(SvHappyReapinatorB, sv_happyreapinator_b, 128, "Reapinator: Hint: If your eyes are flashing you are almost undestructable!", CFGFLAG_SERVER, "Happy reapinator text 2")
+MACRO_CONFIG_STR(SvHappyReapinatorC, sv_happyreapinator_c, 128, "Reapinator: I love you!", CFGFLAG_SERVER, "Happy reapinator text 3")
+MACRO_CONFIG_STR(SvHappyReapinatorD, sv_happyreapinator_d, 128, "Reapinator: You are sooo cool!", CFGFLAG_SERVER, "Happy reapinator text 4")
+MACRO_CONFIG_STR(SvHappyReapinatorE, sv_happyreapinator_e, 128, "Reapinator: A real reaper!", CFGFLAG_SERVER, "Happy reapinator test 5")
+MACRO_CONFIG_INT(SurviveBonus, sv_survivebonus, 3,0,9999,CFGFLAG_SERVER, "Score bonus for survive at game-end.")
+MACRO_CONFIG_INT(SvDummy, sv_dummy, 1,0,1,CFGFLAG_SERVER, "Useless empty dummy for vote")
+
+
 
 // debug
 #ifdef CONF_DEBUG // this one can crash the server if not used correctly
diff -rupN teeworlds-b177-r50edfd37-source/src//game/version.h alien-rc4/src//game/version.h
--- teeworlds-b177-r50edfd37-source/src//game/version.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/version.h	2012-06-14 23:57:39.000000000 +0200
@@ -3,6 +3,7 @@
 #ifndef GAME_VERSION_H
 #define GAME_VERSION_H
 #include "generated/nethash.cpp"
-#define GAME_VERSION "0.6.1"
+#define GAME_VERSION "0.6 trunk"
 #define GAME_NETVERSION "0.6 " GAME_NETVERSION_HASH
+static const char GAME_RELEASE_VERSION[8] = {'0', '.', '6', '1', 0};
 #endif
diff -rupN teeworlds-b177-r50edfd37-source/src//mastersrv/mastersrv.cpp alien-rc4/src//mastersrv/mastersrv.cpp
--- teeworlds-b177-r50edfd37-source/src//mastersrv/mastersrv.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//mastersrv/mastersrv.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -1,20 +1,24 @@
 /* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
 /* If you are missing that file, acquire a complete release at teeworlds.com.                */
 #include <base/system.h>
-#include <engine/shared/network.h>
-#include <engine/shared/config.h>
+
+#include <engine/config.h>
 #include <engine/console.h>
-#include <engine/storage.h>
 #include <engine/kernel.h>
+#include <engine/storage.h>
+
+#include <engine/shared/config.h>
+#include <engine/shared/netban.h>
+#include <engine/shared/network.h>
 
 #include "mastersrv.h"
 
+
 enum {
 	MTU = 1400,
 	MAX_SERVERS_PER_PACKET=75,
 	MAX_PACKETS=16,
 	MAX_SERVERS=MAX_SERVERS_PER_PACKET*MAX_PACKETS,
-	MAX_BANS=128,
 	EXPIRE_TIME = 90
 };
 
@@ -77,14 +81,7 @@ static CCountPacketData m_CountData;
 static CCountPacketData m_CountDataLegacy;
 
 
-struct CBanEntry
-{
-	NETADDR m_Address;
-	int64 m_Expire;
-};
-
-static CBanEntry m_aBans[MAX_BANS];
-static int m_NumBans = 0;
+CNetBan m_NetBan;
 
 static CNetClient m_NetChecker; // NAT/FW checker
 static CNetClient m_NetOp; // main
@@ -217,9 +214,9 @@ void AddCheckserver(NETADDR *pInfo, NETA
 	}
 
 	char aAddrStr[NETADDR_MAXSTRSIZE];
-	net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr));
+	net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr), true);
 	char aAltAddrStr[NETADDR_MAXSTRSIZE];
-	net_addr_str(pAlt, aAltAddrStr, sizeof(aAltAddrStr));
+	net_addr_str(pAlt, aAltAddrStr, sizeof(aAltAddrStr), true);
 	dbg_msg("mastersrv", "checking: %s (%s)", aAddrStr, aAltAddrStr);
 	m_aCheckServers[m_NumCheckServers].m_Address = *pInfo;
 	m_aCheckServers[m_NumCheckServers].m_AltAddress = *pAlt;
@@ -237,7 +234,7 @@ void AddServer(NETADDR *pInfo, ServerTyp
 		if(net_addr_comp(&m_aServers[i].m_Address, pInfo) == 0)
 		{
 			char aAddrStr[NETADDR_MAXSTRSIZE];
-			net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr));
+			net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr), true);
 			dbg_msg("mastersrv", "updated: %s", aAddrStr);
 			m_aServers[i].m_Expire = time_get()+time_freq()*EXPIRE_TIME;
 			return;
@@ -252,7 +249,7 @@ void AddServer(NETADDR *pInfo, ServerTyp
 	}
 
 	char aAddrStr[NETADDR_MAXSTRSIZE];
-	net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr));
+	net_addr_str(pInfo, aAddrStr, sizeof(aAddrStr), true);
 	dbg_msg("mastersrv", "added: %s", aAddrStr);
 	m_aServers[m_NumServers].m_Address = *pInfo;
 	m_aServers[m_NumServers].m_Expire = time_get()+time_freq()*EXPIRE_TIME;
@@ -271,9 +268,9 @@ void UpdateServers()
 			if(m_aCheckServers[i].m_TryCount == 10)
 			{
 				char aAddrStr[NETADDR_MAXSTRSIZE];
-				net_addr_str(&m_aCheckServers[i].m_Address, aAddrStr, sizeof(aAddrStr));
+				net_addr_str(&m_aCheckServers[i].m_Address, aAddrStr, sizeof(aAddrStr), true);
 				char aAltAddrStr[NETADDR_MAXSTRSIZE];
-				net_addr_str(&m_aCheckServers[i].m_AltAddress, aAltAddrStr, sizeof(aAltAddrStr));
+				net_addr_str(&m_aCheckServers[i].m_AltAddress, aAltAddrStr, sizeof(aAltAddrStr), true);
 				dbg_msg("mastersrv", "check failed: %s (%s)", aAddrStr, aAltAddrStr);
 
 				// FAIL!!
@@ -305,7 +302,7 @@ void PurgeServers()
 		{
 			// remove server
 			char aAddrStr[NETADDR_MAXSTRSIZE];
-			net_addr_str(&m_aServers[i].m_Address, aAddrStr, sizeof(aAddrStr));
+			net_addr_str(&m_aServers[i].m_Address, aAddrStr, sizeof(aAddrStr), true);
 			dbg_msg("mastersrv", "expired: %s", aAddrStr);
 			m_aServers[i] = m_aServers[m_NumServers-1];
 			m_NumServers--;
@@ -315,53 +312,9 @@ void PurgeServers()
 	}
 }
 
-bool CheckBan(NETADDR Addr)
-{
-	for(int i = 0; i < m_NumBans; i++)
-	{
-		if(net_addr_comp(&m_aBans[i].m_Address, &Addr) == 0)
-		{
-			return true;
-		}
-	}
-	Addr.port = 0;
-	for(int i = 0; i < m_NumBans; i++)
-	{
-		if(net_addr_comp(&m_aBans[i].m_Address, &Addr) == 0)
-		{
-			return true;
-		}
-	}
-	return false;
-}
-
-void ConAddBan(IConsole::IResult *pResult, void *pUser)
-{
-	if(m_NumBans == MAX_BANS)
-	{
-		dbg_msg("mastersrv", "error: banlist is full");
-		return;
-	}
-
-	if(net_addr_from_str(&m_aBans[m_NumBans].m_Address, pResult->GetString(0)) != 0)
-	{
-		dbg_msg("mastersrv", "error: invalid address");
-		return;
-	}
-
-	if(CheckBan(m_aBans[m_NumBans].m_Address))
-	{
-		dbg_msg("mastersrv", "duplicate ban: %s", pResult->GetString(0));
-		return;
-	}
-
-	dbg_msg("mastersrv", "ban added: %s", pResult->GetString(0));
-	m_NumBans++;
-}
-
 void ReloadBans()
 {
-	m_NumBans = 0;
+	m_NetBan.UnbanAll();
 	m_pConsole->ExecuteFile("master.cfg");
 }
 
@@ -374,16 +327,40 @@ int main(int argc, const char **argv) //
 	dbg_logger_stdout();
 	net_init();
 
-	mem_zero(&BindAddr, sizeof(BindAddr));
-	BindAddr.type = NETTYPE_ALL;
-	BindAddr.port = MASTERSERVER_PORT;
+	mem_copy(m_CountData.m_Header, SERVERBROWSE_COUNT, sizeof(SERVERBROWSE_COUNT));
+	mem_copy(m_CountDataLegacy.m_Header, SERVERBROWSE_COUNT_LEGACY, sizeof(SERVERBROWSE_COUNT_LEGACY));
+
+	IKernel *pKernel = IKernel::Create();
+	IStorage *pStorage = CreateStorage("Teeworlds", IStorage::STORAGETYPE_BASIC, argc, argv);
+	IConfig *pConfig = CreateConfig();
+	m_pConsole = CreateConsole(CFGFLAG_MASTER);
+	
+	bool RegisterFail = !pKernel->RegisterInterface(pStorage);
+	RegisterFail |= !pKernel->RegisterInterface(m_pConsole);
+	RegisterFail |= !pKernel->RegisterInterface(pConfig);
+
+	if(RegisterFail)
+		return -1;
+
+	pConfig->Init();
+	m_NetBan.Init(m_pConsole, pStorage);
+	if(argc > 1) // ignore_convention
+		m_pConsole->ParseArguments(argc-1, &argv[1]); // ignore_convention
+
+	if(g_Config.m_Bindaddr[0] && net_host_lookup(g_Config.m_Bindaddr, &BindAddr, NETTYPE_ALL) == 0)
+		BindAddr.port = MASTERSERVER_PORT;
+	else
+	{
+		mem_zero(&BindAddr, sizeof(BindAddr));
+		BindAddr.type = NETTYPE_ALL;
+		BindAddr.port = MASTERSERVER_PORT;
+	}
 
 	if(!m_NetOp.Open(BindAddr, 0))
 	{
 		dbg_msg("mastersrv", "couldn't start network (op)");
 		return -1;
 	}
-
 	BindAddr.port = MASTERSERVER_PORT+1;
 	if(!m_NetChecker.Open(BindAddr, 0))
 	{
@@ -391,21 +368,6 @@ int main(int argc, const char **argv) //
 		return -1;
 	}
 
-	mem_copy(m_CountData.m_Header, SERVERBROWSE_COUNT, sizeof(SERVERBROWSE_COUNT));
-	mem_copy(m_CountDataLegacy.m_Header, SERVERBROWSE_COUNT_LEGACY, sizeof(SERVERBROWSE_COUNT_LEGACY));
-
-	IKernel *pKernel = IKernel::Create();
-	IStorage *pStorage = CreateStorage("Teeworlds", argc, argv);
-
-	m_pConsole = CreateConsole(CFGFLAG_MASTER);
-	m_pConsole->Register("ban", "s", CFGFLAG_MASTER, ConAddBan, 0, "Ban IP from mastersrv");
-
-	bool RegisterFail = !pKernel->RegisterInterface(pStorage);
-	RegisterFail |= !pKernel->RegisterInterface(m_pConsole);
-
-	if(RegisterFail)
-		return -1;
-
 	dbg_msg("mastersrv", "started");
 
 	while(1)
@@ -418,7 +380,8 @@ int main(int argc, const char **argv) //
 		while(m_NetOp.Recv(&Packet))
 		{
 			// check if the server is banned
-			if(CheckBan(Packet.m_Address)) continue;
+			if(m_NetBan.IsBanned(&Packet.m_Address, 0, 0))
+				continue;
 
 			if(Packet.m_DataSize == sizeof(SERVERBROWSE_HEARTBEAT)+2 &&
 				mem_comp(Packet.m_pData, SERVERBROWSE_HEARTBEAT, sizeof(SERVERBROWSE_HEARTBEAT)) == 0)
@@ -519,7 +482,8 @@ int main(int argc, const char **argv) //
 		while(m_NetChecker.Recv(&Packet))
 		{
 			// check if the server is banned
-			if(CheckBan(Packet.m_Address)) continue;
+			if(m_NetBan.IsBanned(&Packet.m_Address, 0, 0))
+				continue;
 
 			if(Packet.m_DataSize == sizeof(SERVERBROWSE_FWRESPONSE) &&
 				mem_comp(Packet.m_pData, SERVERBROWSE_FWRESPONSE, sizeof(SERVERBROWSE_FWRESPONSE)) == 0)
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/crapnet.cpp alien-rc4/src//tools/crapnet.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/crapnet.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//tools/crapnet.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -129,7 +129,7 @@ void Run(int Port, NETADDR Dest)
 			if(m_ConfigLog)
 			{
 				char aAddrStr[NETADDR_MAXSTRSIZE];
-				net_addr_str(&From, aAddrStr, sizeof(aAddrStr));
+				net_addr_str(&From, aAddrStr, sizeof(aAddrStr), true);
 				dbg_msg("crapnet", "<< %08d %s (%d)", p->m_ID, aAddrStr, p->m_DataSize);
 			}
 		}
@@ -193,7 +193,7 @@ void Run(int Port, NETADDR Dest)
 				if(m_ConfigLog)
 				{
 					char aAddrStr[NETADDR_MAXSTRSIZE];
-					net_addr_str(&p->m_SendTo, aAddrStr, sizeof(aAddrStr));
+					net_addr_str(&p->m_SendTo, aAddrStr, sizeof(aAddrStr), true);
 					dbg_msg("crapnet", ">> %08d %s (%d) %s", p->m_ID, aAddrStr, p->m_DataSize, aFlags);
 				}
 
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/fake_server.cpp alien-rc4/src//tools/fake_server.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/fake_server.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//tools/fake_server.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -113,7 +113,7 @@ static int Run()
 	int64 NextHeartBeat = 0;
 	NETADDR BindAddr = {NETTYPE_IPV4, {0},0};
 
-	if(!pNet->Open(BindAddr, 0, 0, 0))
+	if(!pNet->Open(BindAddr, 0, 0, 0, 0))
 		return 0;
 
 	while(1)
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/map_resave.cpp alien-rc4/src//tools/map_resave.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/map_resave.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//tools/map_resave.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -6,7 +6,7 @@
 
 int main(int argc, const char **argv)
 {
-	IStorage *pStorage = CreateStorage("Teeworlds", argc, argv);
+	IStorage *pStorage = CreateStorage("Teeworlds", IStorage::STORAGETYPE_BASIC, argc, argv);
 	int Index, ID = 0, Type = 0, Size;
 	void *pPtr;
 	char aFileName[1024];
@@ -16,7 +16,7 @@ int main(int argc, const char **argv)
 	if(!pStorage || argc != 3)
 		return -1;
 
-	str_format(aFileName, sizeof(aFileName), "maps/%s", argv[2]);
+	str_format(aFileName, sizeof(aFileName), "%s", argv[2]);
 
 	if(!DataFile.Open(pStorage, argv[1], IStorage::TYPE_ALL))
 		return -1;
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/map_version.cpp alien-rc4/src//tools/map_version.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/map_version.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//tools/map_version.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -44,7 +44,7 @@ int MaplistCallback(const char *pName, i
 int main(int argc, const char **argv) // ignore_convention
 {
 	IKernel *pKernel = IKernel::Create();
-	s_pStorage = CreateStorage("Teeworlds", argc, argv);
+	s_pStorage = CreateStorage("Teeworlds", IStorage::STORAGETYPE_BASIC, argc, argv);
 	s_pEngineMap = CreateEngineMap();
 
 	bool RegisterFail = !pKernel->RegisterInterface(s_pStorage);
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/tileset_borderadd.cpp alien-rc4/src//tools/tileset_borderadd.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/tileset_borderadd.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//tools/tileset_borderadd.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,86 @@
+/* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
+/* If you are missing that file, acquire a complete release at teeworlds.com.                */
+#include <base/math.h>
+#include <base/system.h>
+#include <engine/external/pnglite/pnglite.h>
+
+typedef struct
+{
+	unsigned char r, g, b, a;
+} CPixel;
+
+static void TilesetBorderadd(int w, int h, CPixel *pSrc, CPixel *pDest)
+{
+	int TileW = w/16;
+	int TileH = h/16;
+
+	for(int tx = 0; tx < 16; tx++)
+	{
+		for(int ty = 0; ty < 16; ty++)
+		{
+			for(int x = 0; x < TileW + 4; x++)
+			{
+				for(int y = 0; y < TileH + 4; y++)
+				{
+					int SourceX = tx * TileW + clamp(x - 2, 0, TileW - 1);
+					int SourceY = ty * TileH + clamp(y - 2, 0, TileH - 1);
+					int DestX = tx * (TileW + 4) + x;
+					int DestY = ty * (TileH + 4) + y;
+
+					int SourceI = SourceY * w + SourceX;
+					int DestI = DestY * (w + 16 * 4) + DestX;
+
+					pDest[DestI] = pSrc[SourceI];
+
+				}
+			}
+		}
+	}
+}
+
+
+int FixFile(const char *pFileName)
+{
+	png_t Png;
+	CPixel *pBuffer[2] = {0,0};
+
+	png_init(0, 0);
+	png_open_file(&Png, pFileName);
+
+	if(Png.color_type != PNG_TRUECOLOR_ALPHA)
+	{
+		dbg_msg("tileset_borderadd", "%s: not an RGBA image", pFileName);
+		return 1;
+	}
+
+	int w = Png.width;
+	int h = Png.height;
+
+	pBuffer[0] = (CPixel*)mem_alloc(w*h*sizeof(CPixel), 1);
+	pBuffer[1] = (CPixel*)mem_alloc((w+16*4)*(h+16*4)*sizeof(CPixel), 1);
+	png_get_data(&Png, (unsigned char *)pBuffer[0]);
+	png_close_file(&Png);
+
+	TilesetBorderadd(w, h, pBuffer[0], pBuffer[1]);
+
+	// save here
+	png_open_file_write(&Png, pFileName);
+	png_set_data(&Png, w + 16 * 4, h + 16 * 4, 8, PNG_TRUECOLOR_ALPHA, (unsigned char *)pBuffer[1]);
+	png_close_file(&Png);
+
+	return 0;
+}
+
+int main(int argc, const char **argv)
+{
+	dbg_logger_stdout();
+	if(argc == 1)
+	{
+		dbg_msg("Usage", "%s FILE1 [ FILE2... ]", argv[0]);
+		return -1;
+	}
+
+	for(int i = 1; i < argc; i++)
+		FixFile(argv[i]);
+	return 0;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/tileset_borderrem.cpp alien-rc4/src//tools/tileset_borderrem.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/tileset_borderrem.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//tools/tileset_borderrem.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,86 @@
+/* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
+/* If you are missing that file, acquire a complete release at teeworlds.com.                */
+#include <base/math.h>
+#include <base/system.h>
+#include <engine/external/pnglite/pnglite.h>
+
+typedef struct
+{
+	unsigned char r, g, b, a;
+} CPixel;
+
+static void TilesetBorderrem(int w, int h, CPixel *pSrc, CPixel *pDest)
+{
+	int TileW = w/16;
+	int TileH = h/16;
+
+	for(int tx = 0; tx < 16; tx++)
+	{
+		for(int ty = 0; ty < 16; ty++)
+		{
+			for(int x = 0; x < TileW - 4; x++)
+			{
+				for(int y = 0; y < TileH - 4; y++)
+				{
+					int SourceX = tx * TileW + x + 2;
+					int SourceY = ty * TileH + y + 2;
+					int DestX = tx * (TileW - 4) + x;
+					int DestY = ty * (TileH - 4) + y;
+
+					int SourceI = SourceY * w + SourceX;
+					int DestI = DestY * (w - 16 * 4) + DestX;
+
+					pDest[DestI] = pSrc[SourceI];
+
+				}
+			}
+		}
+	}
+}
+
+
+int FixFile(const char *pFileName)
+{
+	png_t Png;
+	CPixel *pBuffer[2] = {0,0};
+
+	png_init(0, 0);
+	png_open_file(&Png, pFileName);
+
+	if(Png.color_type != PNG_TRUECOLOR_ALPHA)
+	{
+		dbg_msg("tileset_borderrem", "%s: not an RGBA image", pFileName);
+		return 1;
+	}
+
+	int w = Png.width;
+	int h = Png.height;
+
+	pBuffer[0] = (CPixel*)mem_alloc(w*h*sizeof(CPixel), 1);
+	pBuffer[1] = (CPixel*)mem_alloc((w-16*4)*(h-16*4)*sizeof(CPixel), 1);
+	png_get_data(&Png, (unsigned char *)pBuffer[0]);
+	png_close_file(&Png);
+
+	TilesetBorderrem(w, h, pBuffer[0], pBuffer[1]);
+
+	// save here
+	png_open_file_write(&Png, pFileName);
+	png_set_data(&Png, w - 16 * 4, h - 16 * 4, 8, PNG_TRUECOLOR_ALPHA, (unsigned char *)pBuffer[1]);
+	png_close_file(&Png);
+
+	return 0;
+}
+
+int main(int argc, const char **argv)
+{
+	dbg_logger_stdout();
+	if(argc == 1)
+	{
+		dbg_msg("Usage", "%s FILE1 [ FILE2... ]", argv[0]);
+		return -1;
+	}
+
+	for(int i = 1; i < argc; i++)
+		FixFile(argv[i]);
+	return 0;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//tools/tileset_borderset.cpp alien-rc4/src//tools/tileset_borderset.cpp
--- teeworlds-b177-r50edfd37-source/src//tools/tileset_borderset.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//tools/tileset_borderset.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,78 @@
+/* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
+/* If you are missing that file, acquire a complete release at teeworlds.com.                */
+#include <base/math.h>
+#include <base/system.h>
+#include <engine/external/pnglite/pnglite.h>
+
+typedef struct
+{
+	unsigned char r, g, b, a;
+} CPixel;
+
+static void TilesetBorderset(int w, int h, CPixel *pSrc, CPixel *pDest)
+{
+	int TileW = w/16;
+	int TileH = h/16;
+
+	for(int tx = 0; tx < 16; tx++)
+	{
+		for(int ty = 0; ty < 16; ty++)
+		{
+			for(int x = 0; x < TileW; x++)
+			{
+				for(int y = 0; y < TileH; y++)
+				{
+					#define TILE_INDEX(tx_, ty_, x_, y_) (((ty_) * TileH + (y_)) * w + (tx_) * TileW + (x_))
+					pDest[TILE_INDEX(tx, ty, x, y)] = pSrc[TILE_INDEX(tx, ty, clamp(x, 2, TileW - 3), clamp(y, 2, TileH - 3))];
+				}
+			}
+		}
+	}
+}
+
+
+int FixFile(const char *pFileName)
+{
+	png_t Png;
+	CPixel *pBuffer[2] = {0,0};
+
+	png_init(0, 0);
+	png_open_file(&Png, pFileName);
+
+	if(Png.color_type != PNG_TRUECOLOR_ALPHA)
+	{
+		dbg_msg("tileset_borderset", "%s: not an RGBA image", pFileName);
+		return 1;
+	}
+
+	int w = Png.width;
+	int h = Png.height;
+
+	pBuffer[0] = (CPixel*)mem_alloc(w*h*sizeof(CPixel), 1);
+	pBuffer[1] = (CPixel*)mem_alloc(w*h*sizeof(CPixel), 1);
+	png_get_data(&Png, (unsigned char *)pBuffer[0]);
+	png_close_file(&Png);
+
+	TilesetBorderset(w, h, pBuffer[0], pBuffer[1]);
+
+	// save here
+	png_open_file_write(&Png, pFileName);
+	png_set_data(&Png, w, h, 8, PNG_TRUECOLOR_ALPHA, (unsigned char *)pBuffer[1]);
+	png_close_file(&Png);
+
+	return 0;
+}
+
+int main(int argc, const char **argv)
+{
+	dbg_logger_stdout();
+	if(argc == 1)
+	{
+		dbg_msg("Usage", "%s FILE1 [ FILE2... ]", argv[0]);
+		return -1;
+	}
+
+	for(int i = 1; i < argc; i++)
+		FixFile(argv[i]);
+	return 0;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//versionsrv/versionsrv.cpp alien-rc4/src//versionsrv/versionsrv.cpp
--- teeworlds-b177-r50edfd37-source/src//versionsrv/versionsrv.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//versionsrv/versionsrv.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -4,6 +4,8 @@
 
 #include <engine/shared/network.h>
 
+#include <game/version.h>
+
 #include "versionsrv.h"
 
 enum {
@@ -57,10 +59,10 @@ void BuildPackets()
 void SendVer(NETADDR *pAddr)
 {
 	CNetChunk p;
-	unsigned char aData[sizeof(VERSIONSRV_VERSION) + sizeof(VERSION_DATA)];
+	unsigned char aData[sizeof(VERSIONSRV_VERSION) + sizeof(GAME_RELEASE_VERSION)];
 
 	mem_copy(aData, VERSIONSRV_VERSION, sizeof(VERSIONSRV_VERSION));
-	mem_copy(aData + sizeof(VERSIONSRV_VERSION), VERSION_DATA, sizeof(VERSION_DATA));
+	mem_copy(aData + sizeof(VERSIONSRV_VERSION), GAME_RELEASE_VERSION, sizeof(GAME_RELEASE_VERSION));
 
 	p.m_ClientID = -1;
 	p.m_Address = *pAddr;
diff -rupN teeworlds-b177-r50edfd37-source/src//versionsrv/versionsrv.h alien-rc4/src//versionsrv/versionsrv.h
--- teeworlds-b177-r50edfd37-source/src//versionsrv/versionsrv.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//versionsrv/versionsrv.h	2012-06-14 23:57:39.000000000 +0200
@@ -28,8 +28,6 @@ static CMapVersion s_aMapVersionList[] =
 };
 static const int s_NumMapVersionItems = sizeof(s_aMapVersionList)/sizeof(CMapVersion);
 
-static const unsigned char VERSION_DATA[] = {0x00, 0, 6, 0};
-
 static const unsigned char VERSIONSRV_GETVERSION[] = {255, 255, 255, 255, 'v', 'e', 'r', 'g'};
 static const unsigned char VERSIONSRV_VERSION[] = {255, 255, 255, 255, 'v', 'e', 'r', 's'};
 
